const CACHE_NAME = 'MeeChat_v1.3.1';
let urlsToCache = ["//static.meechat.me/cdn/mee.chat/dist/css/chunk-01808817.8fbd3b89.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-036131c7.8c600070.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-0b1259b6.70592e1b.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-0eaafafc.3c90023f.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-2d51432a.58aeec88.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-3ea559d0.ad32a260.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-4292ad10.7fff5891.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-5724c4f5.0a1861ba.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-62134125.94a478f1.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-657e9848.addafef4.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-65c55dcc.4a300cbe.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-66dc197a.f39190c6.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-7b652306.6f878b63.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-7fe7a04f.744165bf.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-9394eafc.12756aeb.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-c77266be.e3e0647a.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-c83e9e48.4cd58218.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-ca5fd2d2.96e28a9d.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-cfb2763e.d5142c58.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-common.db3c2412.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-ef72ea28.1222471e.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-ffa4c280.72bc9530.css","//static.meechat.me/cdn/mee.chat/dist/css/chunk-vendors.5c93e029.css","//static.meechat.me/cdn/mee.chat/dist/css/h5.2b5c3223.css","//static.meechat.me/cdn/mee.chat/dist/css/mini.6c9dec95.css","//static.meechat.me/cdn/mee.chat/dist/css/pc.850268ab.css","//static.meechat.me/cdn/mee.chat/dist/favicon.ico","//static.meechat.me/cdn/mee.chat/dist/fonts/element-icons.2fad952a.woff","//static.meechat.me/cdn/mee.chat/dist/fonts/element-icons.6f0a7632.ttf","/h5.html","//static.meechat.me/cdn/mee.chat/dist/img/bg.261295d3.jpg","//static.meechat.me/cdn/mee.chat/dist/img/bg.71de928a.jpg","//static.meechat.me/cdn/mee.chat/dist/img/bg.eb029f3a.png","//static.meechat.me/cdn/mee.chat/dist/img/bg2.0b28333d.png","//static.meechat.me/cdn/mee.chat/dist/img/h5_bg.e9487380.png","//static.meechat.me/cdn/mee.chat/dist/img/h5_bg2.21b33271.png","//static.meechat.me/cdn/mee.chat/dist/img/h5_bg3.6f597ff4.png","//static.meechat.me/cdn/mee.chat/dist/img/icon-meetone.f0168873.png","//static.meechat.me/cdn/mee.chat/dist/img/icon-tele.0c036f6a.png","//static.meechat.me/cdn/mee.chat/dist/img/icon-tele.88177f4a.png","//static.meechat.me/cdn/mee.chat/dist/img/icons/meechat.png","//static.meechat.me/cdn/mee.chat/dist/img/icons/meechat_icon.png","//static.meechat.me/cdn/mee.chat/dist/img/icons/safari-pinned-tab.svg","//static.meechat.me/cdn/mee.chat/dist/img/loading.b4490fa6.gif","//static.meechat.me/cdn/mee.chat/dist/img/login-logo.6f40e8ff.png","//static.meechat.me/cdn/mee.chat/dist/img/user-ethereum-icon.fdf8b24e.png","//static.meechat.me/cdn/mee.chat/dist/img/user-tron-icon.92300839.png","/index.html","//static.meechat.me/cdn/mee.chat/dist/js/chunk-01808817.c4ed8b7d.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-036131c7.f08cd0f7.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-0b1259b6.cb907381.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-0eaafafc.3635ee38.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-2d51432a.56466103.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-3ea559d0.9164d228.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-4292ad10.fc2ffbef.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-5138ae6c.33139438.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-5724c4f5.c41ca199.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-5c823eee.90d2f764.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-62134125.0ba6a3e5.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-657e9848.19d9a107.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-65c55dcc.231d6199.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-66dc197a.6d882a8b.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-7b652306.ff46bde8.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-7fe7a04f.b093bc60.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-9394eafc.62fe21f1.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-c77266be.7ff2ae04.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-c83e9e48.ab43cd42.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-ca5fd2d2.bc2748e1.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-cfb2763e.dc10bca0.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-common.1ed37b81.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-ef72ea28.6cd977ee.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-ffa4c280.50340646.js","//static.meechat.me/cdn/mee.chat/dist/js/chunk-vendors.aeecc576.js","//static.meechat.me/cdn/mee.chat/dist/js/h5.353c9974.js","//static.meechat.me/cdn/mee.chat/dist/js/mini.f563c001.js","//static.meechat.me/cdn/mee.chat/dist/js/pc.c1078ff8.js","/manifest_h5.json","/manifest_pc.json","/mini.html","/pc.html","//static.meechat.me/cdn/mee.chat/dist/robots.txt","//static.meechat.me/cdn/mee.chat/dist/sw.js"];
// let networkFirstList = ['', 'h5.html', 'mini.html'];
let networkFirstList = [];

self.addEventListener('install', function (event) {
  self.skipWaiting();
  console.log('[ServiceWorker] install')
  event.waitUntil(
    caches.open(CACHE_NAME).then(function(caches){
      console.log('open cache:' + CACHE_NAME);
      let allList = urlsToCache.concat(networkFirstList)
      return caches.addAll(allList);
    })
  )
})

self.addEventListener('activate', function (event) {
  console.log('[ServiceWorker] activate')
  // 只保留白名单的版本
  const cacheWhitelist = [CACHE_NAME];
  event.waitUntil(
    caches.keys().then(function(cacheNames) {
      return Promise.all(
        cacheNames.map(function(cacheName) {
          console.log('遍历缓存：' + cacheName)
          if (cacheWhitelist.indexOf(cacheName) === -1) {
            console.log('删除缓存：' + cacheName)
            return caches.delete(cacheName)
          }
        })
      )
    })
  )
})

self.addEventListener('fetch', function (event) {
  // console.log('[ServiceWorker] Fetch', event.request.url)
  let url = event.request.url.replace(location.origin, '')
  url = url.replace('https:', '')
  let pos = url.indexOf('#')
  if (pos > 0) {
    url = url.substr(0, pos)
  }

  if (urlsToCache.indexOf(url) !== -1) {
    return _cacheFirst(event)
  } else {
    return _networkFirst(event)
  }
})

function _cacheFirst(event) {
  event.respondWith(
    caches.match(event.request).then(function (response) {
      // Cache hit - return response
      if (response) {
        return response;
      }

      return fetch(event.request);
    })
  );
}

function _networkFirst(event) {
  event.respondWith(
      fetch(event.request).then((response) => {
        // console.log('[ServiceWorker] network first, request: ', event.request.url);
        return response
      }).catch (() => {
        caches.match(event.request).then(function (response) {
          // Cache hit - return response
          if (response) {
            // console.log('[ServiceWorker] cache first, From cache:', event.request.url)
            return response;
          }

          // console.log('[ServiceWorker] cache first, From network:', event.request.url)
          return fetch(event.request);
        })
      })
  );
}

self.addEventListener('error', function (event) {
  console.log('[ServiceWorker] error', event)
})

self.addEventListener('push', function (event) {
  console.log('[Service Worker] 收到通知', event);
  function decodeUnicode (str) {
    str = str.replace(/\\/g, '%')
    str = unescape(str)
    str = str.replace(/%/g, '\\')
    str = str.replace(/\\/g, '')
    return str
  }

  let data = JSON.parse(event.data.text())
  const title = decodeUnicode(data.title)
  const options = {
    body: decodeUnicode(data.content),
    icon: 'img/icons/meechat.png',
    tag: data.tag,
    data: data.data,
  }
  event.waitUntil(self.registration.showNotification(title, options))
})

// 点击跳转
self.addEventListener('notificationclick', function (event) {
  console.log('[Service Worker] 点击通知', event);
  let data = event.notification.data
  let url = data && data.url || 'https://mee.chat/'

  event.notification.close()
  event.waitUntil(
      clients.openWindow(url)
  )
})
